package com.loafle.overflow.central.module.meta.service;

import com.loafle.overflow.central.module.meta.dao.MetaPortTypeDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaPortType;
import com.loafle.overflow.service.central.meta.MetaPortTypeService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by snoop on 17. 7. 27.
 */
@Service("MetaPortTypeService")
public class CentralMetaPortTypeService implements MetaPortTypeService {

  @Autowired
  private MetaPortTypeDAO metaPortTypeDAO;

  @Override
  public MetaPortType regist(MetaPortType metaCryptoType) throws OverflowException {
    return this.metaPortTypeDAO.save(metaCryptoType);
  }

  @Override
  public MetaPortType readByKey(String key) throws OverflowException {
    return this.metaPortTypeDAO.findByKey(key);
  }

  @Override
  public List<MetaPortType> readAll() throws OverflowException {
    return this.metaPortTypeDAO.findAll();
  }
}
