package com.loafle.overflow.central.spring;

import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.context.annotation.*;
import org.springframework.context.support.PropertySourcesPlaceholderConfigurer;

/**
 * Created by insanity on 17. 6. 13.
 */
@Configuration
@ComponentScan(basePackages = {
    "com.loafle.overflow" }, excludeFilters = @ComponentScan.Filter({ Configuration.class }))
@EnableAspectJAutoProxy(proxyTargetClass = true)
@Import({ JdbcConfiguration.class, MailConfiguration.class, RedisConfiguration.class, CacheConfiguration.class })
@PropertySource({ "classpath:database.properties", "classpath:mail.properties", "classpath:redis.properties",
    "classpath:cache.properties" })
public class AppConfig {
  // @Bean
  // public static PropertyPlaceholderConfigurer propertyPlaceholderConfigurer() {
  // PropertyPlaceholderConfigurer ppc = new PropertyPlaceholderConfigurer();
  //// ppc.setLocation(new ClassPathResource("database.properties"));
  // ppc.setLocations(new Resource[] {
  // new ClassPathResource("database.properties"),
  // new ClassPathResource("mail.properties"),
  // new ClassPathResource("redis.properties")
  // });
  // ppc.setIgnoreUnresolvablePlaceholders(true);
  //
  // return ppc;
  // }
  @Bean
  public PropertySourcesPlaceholderConfigurer propertySourcesPlaceholderConfigurer() {
    return new PropertySourcesPlaceholderConfigurer();
  }

  // @Bean
  // public Gson gson() {
  // GsonBuilder builder = new GsonBuilder();
  // builder.excludeFieldsWithModifiers(Modifier.TRANSIENT, Modifier.PRIVATE);
  // // builder.excludeFieldsWithoutExposeAnnotation();
  // return builder.create();
  // }
  @Bean
  public ObjectMapper getObjectMapper() {
    ObjectMapper objectMapper = new ObjectMapper();
    objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
    return objectMapper;
  }

}
